﻿
//文件 - IAnim.js
/**
 * Created by 七夕小雨 on 2016/11/7.
 */

function IAnim(bmps, z, viewport){
    /**
     * 是否重复播放动画
     */
    this.isLoop = false;
    /**
     * 动画播放的spriet对象
     */
    this.sanim = null;

    var statr = false;
    var bitmaps = new Array();
    var speed = 1;
    var index = 0;
    var speed_now = 1;
    var finishAnim = null;
    var onFrameAnim = {};
    var times = 0;

    var am = this;

    Object.defineProperty(this, "x", {
        get: function () {
            return am.sanim.x;
        },
        set: function (value) {
            am.sanim.x = value;
        }
    });

    Object.defineProperty(this, "y", {
        get: function () {
            return am.sanim.y;
        },
        set: function (value) {
            am.sanim.y = value;
        }
    });

    Object.defineProperty(this, "z", {
        get: function () {
            return am.z;
        },
        set: function (value) {
            am.sanim.z = value;
        }
    });


    if(viewport == undefined){
        init(bmps,z,null);
    }else{
        init(bmps,z,viewport);
    }

    Object.defineProperty(this, "onload", {
        set: function (fc) {
            am.sanim.onload = function(){
                fc(am);
            }
        }
    });

    function init( bmps, z, viewport,fc){
        statr = false;
        am.isLoop = false;
        am.sanim = new ISprite(bmps[0],viewport);
        am.sanim.z = z;
        index = -1;
        bitmaps = bmps;
    }

    this.setPlaytimes = function(times){
        this.times = times;
    };

    this.setIndex = function(index){
        this.sanim.setBitmap(bitmaps[index]);
    };

    this.setXY = function(x,y){
        this.sanim.x = x;
        this.sanim.y = y;
    };

    this.setSpeed = function(s){
        speed = s;
        speed_now = s;
    };

    this.start = function () {
        statr = true;
        this.sanim.visible = true;
        this.sanim.setBitmap(bitmaps[0]);
        if(index >= bitmaps.length){
            index = -1;
        }
    };

    this.stop = function(){
        statr = false;
        this.sanim.visible = false;
        index = -1;
    };

    this.setBitmaps = function(bmps, isDispose){
        this.stop();
        if(isDispose){
            bitmaps = [];
        }
        bitmaps = bmps;
    };

    this.update = function(){
        if(!statr) return;
        if(speed_now > 0){
            speed_now -= 1;
            if(speed_now == 0){
                speed_now = speed;
                index += 1;
                if(index < bitmaps.length){
                    if(onFrameAnim[index] != null){
                        onFrameAnim[index](am);
                    }
                    this.sanim.setBitmap(bitmaps[index]);
                }else{
                    if(this.isLoop){
                        index = 0;
                        this.sanim.setBitmap(bitmaps[index]);
                    }else{
                        if(times > 0){
                            times -= 1;
                            index = 0;
                            return;
                        }
                        statr = false;
                        index = -1;
                        this.sanim.visible = false;
                        if(finishAnim != null){
                            finishAnim(am);
                        }
                    }
                }

            }
        }
    };


    this.pause = function(){
        statr = false;
    };

    this.isFinishd = function(){
        return !statr;
    };

    /**
     * 动画内存释放
     */
    this.dispose = function(){
        this.sanim.disposeMin();
        bitmaps = [];
    };

    this.disposeMin = function(){
        this.sanim.disposeMin();
    };

    this.setOnFinishAnim = function(ofa){
        finishAnim = ofa;
    };

    this.setOnFrameAnim = function(ofa,frame){
        onFrameAnim[frame] = ofa;
    };

    this.removeFrameAnim = function(frame){
        delete onFrameAnim[frame];
    };

    this.clearFrameAnim = function(){
        onFrameAnim = {};
    }

}

//文件 - IAudio.js
/**
 * Created by 七夕小雨 on 2016/11/7.
 */

function IAudio(){}

IAudio.playSE = function(  fileName,  Volume){
    if2d_audio_SEPlay(fileName , parseInt(Volume));
};

IAudio.stopSE = function () {
    if2d_audio_SEStop();
};

IAudio.playVoice = function(fileName,  Volume) {
    if2d_audio_VoicePlay(fileName,parseInt(Volume));
};

IAudio.stopVoice = function () {
    if2d_audio_VoiceStop();
};

IAudio.playBGM = function(fileName,  Volume){
    if2d_audio_BGMPlay(fileName,parseInt(Volume));
};

IAudio.stopBGM = function () {
    if2d_audio_BGMStop();
};

IAudio.playBGS = function(fileName,  Volume){
    if2d_audio_BGSPlay(fileName,parseInt(Volume));
};

IAudio.stopBGS = function () {
    if2d_audio_BGSStop();
};

IAudio.BGMFade = function (time) {
    if2d_audio_BGMFade(parseInt(time));
};

IAudio.BGSFade = function (time) {
    if2d_audio_BGSFade(parseInt(time));
};






//文件 - IBitmap.js
/**
 * Created by 七夕小雨 on 2016/11/3.
 */

function IBitmap(){}

IBitmap.ABitmap = function(path){
    var id = if2d_bmp_ABitmap(path);
    return new Bitmap(id);

};

IBitmap.WBitmap = function(path){
    var id = if2d_bmp_ABitmap(path);
    return new Bitmap(id);
};

IBitmap.CBitmap = function(width,height){
    var id = if2d_bmp_CBitmap(parseInt(width) , parseInt(height));
    return new Bitmap(id);
};

function Bitmap(id){

    this.id = id;
    this.width = if2d_bmp_getWidth(id);
    this.height = if2d_bmp_getHeight(id);
    this.complete = true;

    this.dispose = function(){
        if2d_bmp_dispose(this.id);
    };

    this.loadTexture = function(){
        if2d_bmp_loadTexture(this.id);
    }
    ;

    Object.defineProperty(this, "onload", {
        set: function (fc) {
            fc();
        }
    });

}
//文件 - IBitmapCof.js
/**
 * Created by 七夕小雨 on 2018/6/11.
 */
function IBCof(bitmap,x,y,width,height){

    var _sf = this;
    this.id = -1;
    this.bitmap = bitmap;
    var tx = x;
    var ty = y;
    var twidth = width;
    var theight = height;

    this.id = if2d_bcof_creatBCof(bitmap.id,x,y,width,height);

    this.dispose = function(){
        if2d_bcof_dispoe(this.id)
    };

    Object.defineProperty(this, "x", {
        get: function () {
            return x;
        },
        set: function (value) {
            setX(value);
        }
    });

    Object.defineProperty(this, "y", {
        get: function () {
            return tx;
        },
        set: function (value) {
            setY(value);
        }
    });

    Object.defineProperty(this, "width", {
        get: function () {
            return twidth;
        },
        set: function (value) {
            setWidth(value);
        }
    });

    Object.defineProperty(this, "height", {
        get: function () {
            return theight;
        },
        set: function (value) {
            setHeight(value);
        }
    });

    function setWidth(value){
        twidth = parseInt(value);
        if2d_bcof_setWidth(_sf.id , twidth);
    }

    function setHeight(value){
        theight = parseInt(value);
        if2d_bcof_setHeight(_sf.id , theight);
    }

    function setX(value){
        tx = parseInt(value);
        if2d_bcof_setX(_sf.id,tx);
    }

    function setY(value){
        ty = parseInt(value);
        if2d_bcof_setY(_sf.id,ty);
    }
}
//文件 - IBox.js
/**
 * Created by 七夕小雨 on 2016/11/3.
 */

function IBox(vp){

    var hashMap = [];

    this.length = function(){
        return hashMap.length;
    };

    this.add = function (plane) {
        var index = hashMap.indexOf(plane);
        if(index <= -1){
            hashMap.push(plane);
        }
    };

    this.getAll = function(){
        return hashMap;
    };

    this.remove = function(p){
        hashMap.remove(p);
    };

    this.removeAll = function(){
        hashMap = [];
    };

    this.update = function(){

        for(var i = 0;i<hashMap.length;i++){
            hashMap[i].update();
        }

    }
}
//文件 - IButton.js
/**
 * Created by 七夕小雨 on 2016/11/7.
 */

function IButton(bmp1,bmp2,txt,viewport,isNeedDraw){

    var image = [];
    var enableBitmap = null;
    var back = null;
    var draw1 = null;
    var draw2 = null;
    var name = "";
    var enable = false;
    var mouseOn = false;
    var index = 0;
    this.tag = null;
    var isMoved = false;
    var isNoUp = false;

    var x = 0;
    var y = 0;
    var z = 0;
    var zoomX = 0;
    var zoomY = 0;

    var opacity = 0;

    this.click = IVal.dSound;

    var type = -1;
    var sNum = 1.0;

    var oldZoom;


    this.drawTitle = function( str, x, y){
        if(x == undefined){
            x = -1;
        }
        if(y == undefined){
            y = -1;
        }
        draw1.clearBitmap();
        var w = IFont.getWidth(str, IVal.FontSize);
        var h = IFont.getHeight(str, IVal.FontSize);
        if(x == -1 && y == -1){
            draw1.drawText( str, (draw1.width - w) /2, (draw1.height - h) / 2);
        }else{
            draw1.drawText( str, x, y);
        }
        draw1.updateBitmap();
    };

    this.drawTitleQ = function( str, color, size){
        draw1.clearBitmap();
        var w = IFont.getWidth(str, size);
        var h = IFont.getHeight(str, size);
        draw1.drawTextQ(str, (draw1.width - w) /2, (draw1.height - h) / 2,color,size);
        draw1.updateBitmap();
    };

    var _sf = this;

    if(txt == undefined){
        txt = "";
    }
    name = txt;
    if(viewport == undefined){
        viewport = null;
    }
    if(isNeedDraw == undefined){
        isNeedDraw = false;
    }

    image[0] = bmp1;
    image[1] = bmp2;


    Object.defineProperty(this, "onload", {
        set: function (fc) {
            back.onload = function(){
                if(isNeedDraw){
                    draw2.width = back.width;
                    draw2.height = back.height;
                }
                if(name.length > 0){
                    draw1.width = back.width;
                    draw1.height = back.height;
                    draw1.clearBitmap();
                    _sf.drawTitleQ(name,IVal.FontColor,IVal.FontSize);
                }
                fc(_sf);
            }
        }
    });

    back = new ISprite(image[0],viewport);
    if(isNeedDraw){
        draw2 = new ISprite(IBitmap.CBitmap(back.width, back.height),viewport);
    }
    if(name.length > 0){
        draw1 = new ISprite(IBitmap.CBitmap(back.width, back.height),viewport);
        _sf.drawTitleQ(name,IVal.FontColor,IVal.FontSize);
    }
    enable = true;
    this.z = 0;

    this.toSimple = function(tp,sn){
        type = tp;
        sNum = sn;
        if(tp >= 0){
            back.yx = 0.5;
            back.yy = 0.5;
            if(draw2 != null){
                draw2.yx = 0.5;
                draw2.yy = 0.5;
            }else if(draw1 != null){
                draw1.yx = 0.5;
                draw1.yy = 0.5;
            }
        }
    };

    this.setYXYY = function(yx,yy){
        back.yx = yx;
        back.yy = yy;
        if(draw2 != null){
            draw2.yx = yx;
            draw2.yy = yy;
        }else if(draw1 != null){
            draw1.yx = yx;
            draw1.yy = yy;
        }
    };

    this.setBitmap = function( bmp1, bmp2, dispose){
        if(dispose){
            image[0] = null;
            image[1] = null;
        }
        image[0] = bmp1;
        image[1] = bmp2;
        back.setBitmap(image[0]);
        isMoved = false;
    };

    this.getSprite = function () {
        return draw2;
    };

    this.getText = function () {
        return draw1;
    };

    this.exchange = function(){
        var bmp = image[0];
        image[0] = image[1];
        image[1] = bmp;
    };


    this.dispose = function(){
        if(draw1 != null)draw1.dispose();
        if(draw2 != null)draw2.dispose();
        if(image[0] != null) {
            image[0] = null;
        }
        if(image[1] != null) {
            image[1] = null;
        }
        if(enableBitmap != null) {
            enableBitmap = null;
        }
        image = [];
        back.dispose();
    };

    this.disposeMin = function(){
        if(draw1 != null)draw1.disposeMin();
        if(draw2 != null)draw2.disposeMin();
        back.disposeMin();
    };

    this.isSelected = function(){
        return back.isSelected();
    };

    this.setEnableBitmap = function( bmp){
        enableBitmap = bmp;
    };

    this.setEnable = function( b){
        if(enableBitmap == null) return;
        enable = b;
        if(!b){
            back.setBitmap(enableBitmap);
        }else{
            back.setBitmap(image[0]);
        }
        isMoved = false;
    };

    this.getEnable = function(){
        return enable;
    };

    this.isClick = function(){
        if(!back.visible) return false;
        if(!enable) return false;
        var f = back.isSelectTouch() == 2;
        if(f && this.click != null) this.click.play();
        return f;
    };

    this.isDown = function(){
        return back.isSelected() && IInput.up;
    };

    this.isOn = function(){
        return mouseOn;
    };

    this.cancelSelect = function(){
        if(!mouseOn) return;
        mouseOn  = false;
        var bmp = image[mouseOn ? 1: 0];
        if(bmp != back.getBitmap()){
            back.setBitmap(bmp);
        }
    };

    this.getBack = function(){
        return back;
    };

    this.getX = function(){
        return back.x;
    };

    this.getY = function(){
        return back.y;
    };

    this.getZ = function(){
        return back.z;
    };

    this.setX = function(x){
        back.x = x;
        if(draw1 != null) draw1.x = x;
        if(draw2 != null) draw2.x = x;
    };

    this.setY = function(y){
        back.y = y;
        if(draw1 != null) draw1.y = y;
        if(draw2 != null) draw2.y = y;
    };

    this.setZ = function(z){
        back.z = z;
        if(draw1 != null) draw1.z = z + 2;
        if(draw2 != null) draw2.z = z + 1;
    };

    this.setZoomX = function(x){
        back.zoomX = x;
        if(draw1 != null) draw1.zoomX = x;
        if(draw2 != null) draw2.zoomX = x;
    };

    this.setZoomY = function(y){
        back.zoomY = y;
        if(draw1 != null) draw1.zoomY = y;
        if(draw2 != null) draw2.zoomY = y;
    };

    this.setVisible = function(v){
        back.visible = v;
        if(draw1 != null) draw1.visible = v;
        if(draw2 != null) draw2.visible = v;
    };

    this.width = function(){
        return back.width;
    };

    this.height = function(){
        return back.height;
    };

    this.setOpactiy = function(o){
        back.opacity = o;
        if(draw1 != null) draw1.opacity = o;
        if(draw2 != null) draw2.opacity = o;
    };

    Object.defineProperty(this, "x", {
        get: function () {
            return back.x;
        },
        set: function (value) {
            back.x = value;
            if(draw1 != null) draw1.x = value;
            if(draw2 != null) draw2.x = value;

        }
    });

    Object.defineProperty(this, "y", {
        get: function () {
            return back.y;
        },
        set: function (value) {
            back.y = value;
            if(draw1 != null) draw1.y = value;
            if(draw2 != null) draw2.y = value;

        }
    });

    Object.defineProperty(this, "z", {
        get: function () {
            return back.z;
        },
        set: function (value) {
            back.z = value;
            if(draw1 != null) draw1.z = value + 1;
            if(draw2 != null) draw2.z = value + 2;

        }
    });

    Object.defineProperty(this, "zoomX", {
        get: function () {
            return back.zoomX;
        },
        set: function (value) {
            back.zoomX = value;
            if(draw1 != null) draw1.zoomX = value;
            if(draw2 != null) draw2.zoomX = value;

        }
    });

    Object.defineProperty(this, "zoomY", {
        get: function () {
            return back.zoomY;
        },
        set: function (value) {
            back.zoomY = value;
            if(draw1 != null) draw1.zoomY = value;
            if(draw2 != null) draw2.zoomY = value;

        }
    });

    Object.defineProperty(this, "visible", {
        get: function () {
            return back.visible;
        },
        set: function (value) {
            back.visible = value;
            if(draw1 != null) draw1.visible = value;
            if(draw2 != null) draw2.visible = value;

        }
    });

    Object.defineProperty(this, "opacity", {
        get: function () {
            return back.opacity;
        },
        set: function (value) {
            back.opacity = value;
            if(draw1 != null) draw1.opacity = value;
            if(draw2 != null) draw2.opacity = value;

        }
    });

    Object.defineProperty(this, "width", {
        get: function () {
            return back.width;
        },
        set: function (value) {}
    });

    Object.defineProperty(this, "height", {
        get: function () {
            return back.height;
        },
        set: function (value) {}
    });

    this.fade = function(bo, eo, frame){
        back.fade(bo,eo,frame);
        if(draw1 != null) draw1.fade(bo,eo,frame);
        if(draw2 != null) draw2.fade(bo,eo,frame);
    };

    this.fadeTo = function(o, frame){
        back.fadeTo(o, frame);
        if(draw1 != null) draw1.fadeTo(o, frame);
        if(draw2 != null) draw2.fadeTo(o, frame);
    };

    this.slide = function(bx, by,ex,ey, frame){
        back.slide(bx,by,ex,ey,frame);
        if(draw1 != null) draw1.slide(bx,by,ex,ey,frame);
        if(draw2 != null) draw2.sslide(bx,by,ex,ey,frame);
    };

    this.slideTo = function( x, y, frame){
        back.slideTo(x, y, frame);
        if(draw1 != null) draw1.slideTo(x , y , frame);
        if(draw2 != null) draw2.slideTo(x , y , frame);
    };

    this.scale = function( bzx, bzy,ezx,ezy, frame){
        back.scale(bzx,bzy,ezx,ezy,frame);
        if(draw1 != null) draw1.scale(bzx,bzy,ezx,ezy,frame);
        if(draw2 != null) draw2.scale(bzx,bzy,ezx,ezy,frame);
    };

    this.scaleTo = function( zx, zy, frame){
        back.scaleTo(zx, zy, frame);
        if(draw1 != null) draw1.scaleTo(zx ,zy , frame);
        if(draw2 != null) draw2.scaleTo(zx , zy , frame);
    };

    this.setAction = function(action,args){

        back.addAction.apply(back,arguments);
        if(draw1 != null) draw1.addAction.apply(draw1,arguments);
        if(draw2 != null) draw2.addAction.apply(draw2,arguments)
    };

    this.setActLoop = function( loop){
        back.actionLoop = loop;
        if(draw1 != null) draw1.actionLoop = loop;
        if(draw2 != null) draw2.actionLoop = loop;
    };

    this.getActLoop = function(){
        return back.actionLoop;
    };

    this.update = function(){
        if(!enable) return false;
        if(!back.visible) return false;
        var stutas = back.isSelectTouch();
        if(stutas == 2){
            if(this.click != null) this.click.play();
            return true;
        }
        mouseOn = isMoved || stutas == 1;
        if(type == -1){
            var bmp = image[mouseOn ? 1: 0];
            if(bmp != back.getBitmap()){
                back.setBitmap(bmp);
            }
        }else if(type == 0){
            var zoom = mouseOn ? sNum : 1.0;
            if(back.zoomX != zoom){
                back.zoomX = back.zoomY = zoom;
                if(draw1 != null){
                    draw1.zoomX = draw1.zoomY = zoom;
                }
                if(draw2 != null){
                    draw2.zoomX = draw2.zoomY = zoom;
                }
            }
        }
        return false;

    };


}
//文件 - ICheck.js
/**
 * Created by 七夕小雨 on 2016/11/8.
 */


function ICheck(bmp1,bmp2,txt,vp,select){

    var image = [];
    var checks = [];
    var back = null;
    var text = txt;
    var draw1 = null;
    this.mouseOn = false;
    var selected = false;
    var tempSelect = false;
    var tempMouseOn = false;
    this.tag = null;

    this.click = IVal.dSound;

    if(txt == undefined){
        text = "";
    }
    text = txt;
    if(vp == undefined){
        vp = null;
    }
    if(select == undefined){
        select = false;
    }
    selected = select;

    image = [bmp1,bmp2];

    this.drawTitle = function( str, x, y){
        if(x == undefined){
            x = -1;
        }
        if(y == undefined){
            y = -1;
        }
        draw1.clearBitmap();
        var w = IFont.getWidth(str, IVal.FontSize);
        var h = IFont.getHeight(str, IVal.FontSize);
        if(x == -1 && y == -1){
            draw1.drawText( str, (draw1.width - w) /2, (draw1.height - h) / 2);
        }else{
            draw1.drawText( str, x, y);
        }
        draw1.updateBitmap();
    }

    this.drawTitleQ = function( str, color, size){
        draw1.clearBitmap();
        var w = IFont.getWidth(str, size);
        var h = IFont.getHeight(str, size);
        draw1.drawTextQ(str, (draw1.width - w) /2, (draw1.height - h) / 2,color,size);
        draw1.updateBitmap();
    }

    var _sf = this;

    Object.defineProperty(this, "onload", {
        set: function (fc) {
            back.onload = function(){
                if(text.length > 0){
                    draw1.width = back.width;
                    draw1.height = back.height;
                    _sf.drawTitleQ(text,IVal.FontColor,IVal.FontSize);
                }
                fc(_sf);
            }
        }
    });

    back = new ISprite(selected ? image[0] : image[1],vp);
    tempSelect = false;
    tempMouseOn = false;

    if(text.length > 0){
        draw1 = new ISprite(IBitmap.CBitmap(back.width, back.height),vp);
        _sf.drawTitleQ(text,IVal.FontColor,IVal.FontSize);
    }

    this.getX = function(){
        return back.x;
    };

    this.getY = function(){
        return back.y;
    };

    this.setX = function( x){
        back.x = x;
        if(draw1 != null){
            draw1.x = x;
        }
    };

    this.setY = function(y){
        back.y = y;
        if(draw1 != null){
            draw1.y = y;
        }
    };

    this.setZ = function(z){
        back.z = z;
        if(draw1 != null){
            draw1.z = z + 1;
        }
    };

    this.getWidth = function(){
        return back.width;
    };

    this.getHeight = function(){
        return back.height;
    };

    this.getText = function(){
        return draw1;
    };

    this.getBack = function(){
        return back;
    };

    this.setVisible = function( v){
        back.visible = v;
        if(draw1 != null){
            draw1.visible = v;
        }
    };


    this.setOpacity = function( o){
        back.opacity = o;
        if(draw1 != null){
            draw1.opacity = o;
        }
    };

    Object.defineProperty(this, "x", {
        get: function () {
            return back.x;
        },
        set: function (value) {
            back.x = value;
            if(draw1 != null) draw1.x = value;

        }
    });

    Object.defineProperty(this, "y", {
        get: function () {
            return back.y;
        },
        set: function (value) {
            back.y = value;
            if(draw1 != null) draw1.y = value;

        }
    });

    Object.defineProperty(this, "z", {
        get: function () {
            return back.z;
        },
        set: function (value) {
            back.z = value;
            if(draw1 != null) draw1.z = value + 1;

        }
    });

    Object.defineProperty(this, "zoomX", {
        get: function () {
            return back.zoomX;
        },
        set: function (value) {
            back.zoomX = value;
            if(draw1 != null) draw1.zoomX = value;

        }
    });

    Object.defineProperty(this, "zoomY", {
        get: function () {
            return back.zoomY;
        },
        set: function (value) {
            back.zoomY = value;
            if(draw1 != null) draw1.zoomY = value;

        }
    });

    Object.defineProperty(this, "visible", {
        get: function () {
            return back.visible;
        },
        set: function (value) {
            back.visible = value;
            if(draw1 != null) draw1.visible = value;

        }
    });

    Object.defineProperty(this, "opacity", {
        get: function () {
            return back.opacity;
        },
        set: function (value) {
            back.opacity = value;
            if(draw1 != null) draw1.opacity = value;
        }
    });

    Object.defineProperty(this, "width", {
        get: function () {
            return back.width;
        },
        set: function (value) {}
    });

    Object.defineProperty(this, "height", {
        get: function () {
            return back.height;
        },
        set: function (value) {}
    });

    this.fade = function(bo, eo, frame){
        back.fade(bo,eo,frame);
        if(draw1 != null) draw1.fade(bo,eo,frame);
    };

    this.fadeTo = function(o, frame){
        back.fadeTo(o, frame);
        if(draw1 != null) draw1.fadeTo(o, frame);
    };

    this.slide = function(bx, by,ex,ey, frame){
        back.slide(bx,by,ex,ey,frame);
        if(draw1 != null) draw1.slide(bx,by,ex,ey,frame);
    };

    this.slideTo = function( x, y, frame){
        back.slideTo(x, y, frame);
        if(draw1 != null) draw1.slideTo(x , y , frame);
    };

    this.scale = function( bzx, bzy,ezx,ezy, frame){
        back.scale(bzx,bzy,ezx,ezy,frame);
        if(draw1 != null) draw1.scale(bzx,bzy,ezx,ezy,frame);
    };

    this.scaleTo = function( zx, zy, frame){
        back.scaleTo(zx, zy, frame);
        if(draw1 != null) draw1.scaleTo(zx ,zy , frame);
    };

    this.setAction = function(action,args){
        back.addAction.apply(back,arguments);
        if(draw1 != null) draw1.addAction.apply(draw1,arguments);
    };

    this.width = function(){
        return sprBack.width;
    };

    this.height = function(){
        return sprBack.height;
    };

    this.setZoomX = function( zoomX){
        back.zoomX = zoomX;
        if(draw1 !=  null){
            draw1.zoomX = zoomX;
        }
    };

    this.setZoomY = function( zoomY){
        back.zoomY = zoomY;
        if(draw1 !=  null){
            draw1.zoomY = zoomY;
        }
    };

    this.setActLoop = function( loop){
        back.actionLoop = loop;
        if(draw1 != null) draw1.actionLoop = loop;
    };

    this.getActLoop = function(){
        return back.actionLoop;
    };

    this.setOtherCheck = function(ck){
        checks = ck;
    };

    this.dispose = function(){
        if(draw1 != null)draw1.dispose();
        if(image[0] != null) {
            image[0] = null;
        }
        if(image[1] != null) {
            image[1] = null;
        }
        image = [];
        back.dispose();
    };

    this.disposeMin = function(){
        if(draw1 != null)draw1.disposeMin();
        back.disposeMin();
    };

    this.setSelected = function( s) {
        selected = s;
    };

    this.clickBox = function(){
        if(checks != null){
            for(var i = 0;i<checks.length;i++){
                checks[i].setSelected(false);
            }
        }
        if(this.click != null) this.click.play();
        selected = true;
    };

    this.isClick = function(){
        return this.mouseOn;
    };

    this.isMouseOn = function(){
        return back.isSelect() && IInput.up;
    };

    function updateMoveOn(){
        if(tempSelect != selected || tempMouseOn != this.mouseOn){
            if(selected){
                back.setBitmap(image[1]);
                tempMouseOn = this.mouseOn;
                tempSelect = selected;
            }else{
                var btm = image[this.mouseOn ? 1 : 0];
                if(btm != back.getBitmap()){
                    back.setBitmap(btm);
                }
                tempMouseOn = this.mouseOn;
                tempSelect = selected;
            }
        }
    }

    this.update = function(){
        if(!back.visible) return;
        updateMoveOn();
        this.mouseOn = back.isSelectTouch() == 2;
        if(this.mouseOn){
            this.clickBox();

            return true;
        }
        return false;

    }


}
//文件 - IColor.js
/**
 * Created by 七夕小雨 on 2016/11/3.
 */
function IColor() {
    this.R = 0;
    this.G = 0;
    this.B = 0;
    this.A = 0;

    if(arguments.length == 1){
        var arg = arguments[0].split(",");
        if(arg.length == 4){
            this.R = parseInt(arg[0]);
            this.G = parseInt(arg[1]);
            this.B = parseInt(arg[2]);
            this.A = parseInt(arg[3]);
        }else if(arg.length == 3){
            this.R = parseInt(arg[0]);
            this.G = parseInt(arg[1]);
            this.B = parseInt(arg[2]);
            this.A = 255;
        }
    }else if (arguments.length == 4) {
        this.R = arguments[0];
        this.G = arguments[1];
        this.B = arguments[2];
        this.A = arguments[3];
    } else if(arguments.length == 3){
        this.R = arguments[0];
        this.G = arguments[1];
        this.B = arguments[2];
        this.A = 255;
    }

    this.JColor = function(){
        var a = parseFloat(this.A) / 255.0;
        return "rgba(" + this.R +"," +this.G +"," + this.B + "," + a +")";
    };

    this.TColor = function(){
        return "\\c[" + this.R +"," +this.G +"," + this.B + "]";
    }

}

IColor.Black = function () {
    return new IColor(0, 0, 0);
};

IColor.White = function () {
    return new IColor(255, 255, 255);
};

IColor.Red = function () {
    return new IColor(255, 0, 0);
};

IColor.Blue = function () {
    return new IColor(0, 0, 255);
};

IColor.Green = function () {
    return new IColor(0, 255, 0);
};

IColor.Transparent = function () {
    return new IColor(0, 0, 0, 0);
};

IColor.CreatColor = function (r, g, b) {
    return new IColor(r, g, b, 255);
};

//文件 - IDll.js
/**
 * Created by Admin on 2019/9/19.
 */
function IDll(path){
    var _sf = this;
    this.id = -1;

    this.doStaticFunction = function(namespace,fname,parameter){
        return null;
    };

    this.creatObj = function(namespace){
        return new IDLLObject(_sf.id,namespace);
    };


    function IDLLObject(id,namespace){
        var fid = id;
        this.id = -1;

        this.doFunction = function(fname,ftypes,parameter){
            return null;
        };
    }

}
//文件 - IFont.js
/**
 * Created by 七夕小雨 on 2016/11/7.
 */

function IFont(){}

IFont.getWidth = function(txt,size){
    return if2d_font_getWidth(txt +"", parseInt(size));
};


IFont.getHeight = function (txt,size) {
    return if2d_font_getHeight(txt +"", parseInt(size));
};

IFont.toGroups = function(text){
    var args = [];
    var last = "";
    var gStr = "";
    var wait = false;
    for(var i = 0;i<text.length;i++){
        var min = text.substr(i,1);
        if(min == "["){
            wait = true;
        }
        if(min == "]" && wait){
            wait = false;
        }
        if((IFont.LastSymbol.indexOf(last) >= 0 && !wait) || IFont.NoneSymbol.indexOf(last) >= 0
            || (IFont.CheckText(last) && IFont.CheckText(min))){
            args.push(gStr);
            gStr = min;
        }else{
            gStr += min;
        }
        if(i == text.length - 1){
            args.push(gStr);
        }
        last = min;
    }

    return args;
};

IFont.CheckText = function(str){
    var reg = new RegExp("[\\u4E00-\\u9FFF]+","g");
    if(reg.test(str)){
        return true;
    }
    reg = new RegExp("[\\u3040-\\u309F\\u30A0-\\u30FF]+","g");
    if(reg.test(str)){
        return true;
    }
    reg = new RegExp("[\\u0E00-\\u0E7F]+","g");
    if(reg.test(str)){
        return true;
    }
    return false;
};

IFont.LastSymbol = ["!",")",",",".",":",";","?","]","}","¨","·","ˇ","ˉ","―","‖","’","”","…","∶","、","。","〃",
    "々","〉","》","」","』","】","〕","〗","！","＂","＇","）","，","．","：","；","？","］","｀","｜","｝","～","￠"];

IFont.NoneSymbol = [" ","   ","　"];
//文件 - IInput.js
function IInput() {
}

IInput.down = false;

IInput.Tlong = false;

IInput.move = false;

IInput.up = false;

IInput.tx = 0;
IInput.dx = 0;
IInput.x = 0;
IInput.ty = 0;
IInput.dy = 0;
IInput.y = 0;
IInput.mouseButton = 0;

IInput.touches = [];

IInput.BackButton = false;
IInput.HomeButton = false;
IInput.MenuButton = false;


IInput.keyCodeAry = [];
IInput.keyCodeDelAry = [];

IInput.keyDown = false;
IInput.keyUp = false;


IInput.isKeyDown = function(keyCode){
	return false;
};

IInput.isKeyPress = function(keyCode){
	return false;
};
//文件 - IMain.js
/**
 * Created by 七夕小雨 on 2019/4/24.
 */

var IInputMark1 = false;
var if2d_fuc_inputfuc = null;
var if2d_fuc_ReInput = "";

function mainInit(){

    IVal.GWidth = if2d_val_getGW();
    IVal.GHeight = if2d_val_getGH();

    IVal.Box = new IBox();

    iFActionGameStart();

    if2d_val_setFontSize(IVal.FontSize);
    if2d_val_setFontColor(IVal.FontColor.R,IVal.FontColor.G,IVal.FontColor.B,IVal.FontColor.A);


}

function modInit(){
    IVal.Mods = new IMods(null);

    var oldStart = SStart;

    SStart = function(){
        oldStart.call(this);

        var oldDispose = this.dispose;
        this.dispose = function(){
            oldDispose.call(this);
            for(var key in IVal.Mods.uis){

                var ui = IVal.Mods.uis[key].uis;
                var ctrl = IVal.Mods.uis[key].ctrls;
                for(var uikey in ui){
                    RV.NowUI.uis[uikey] = ui[uikey];
                }

                for(var ctrlkey in ctrl){
                    RV.NowUI.ctrls[ctrlkey] = ctrl[ctrlkey];
                }

            }
        }

    }
}


function mainUpdate(){

    if(if2d_fuc_ReInput != null){
        if(if2d_fuc_inputfuc != null) if2d_fuc_inputfuc(if2d_fuc_ReInput);
        if2d_fuc_ReInput = null;
        if2d_fuc_inputfuc = null;
    }

    IVal.Box.update();

    IInput.x = if2d_input_getGameTouchX();
    IInput.y = if2d_input_getGameTouchY();

    IInput.down = if2d_input_getDown();
    IInput.up = if2d_input_getUp();
    IInput.move = if2d_input_getMove();

    IInput.BackButton = if2d_input_getBackButton();
    IInput.HomeButton = if2d_input_getHomeButton();
    IInput.MenuButton = if2d_input_getMenuButton();


    IInput.touches = [];
    var ary = if2d_input_getTouchs();
    if(ary.length > 0){
        for(var i = 0;i<ary.length / 3;i++){
            IInput.touches[i] = {
                id : ary[i * 3],
                clientX : ary[1 + i * 3],
                clientY : ary[2 + i * 3]
            }
        }
    }


    if(IInput.down){
        if(!IInputMark1){
            IInput.dx = IInput.x;
            IInput.dy = IInput.y;
            IInputMark1 = true;
        }
    }
    if(IInput.up) {
        IInputMark1 = false;
        //IInput.touches = [];
    }

    if(IVal.scene != null){
        IVal.scene.update();
    }
}

String.prototype.replaceAll = function(reallyDo, replaceWith, ignoreCase) {
    if (!RegExp.prototype.isPrototypeOf(reallyDo)) {
        return this.replace(new RegExp(reallyDo, (ignoreCase ? "gi": "g")), replaceWith);
    } else {
        return this.replace(reallyDo, replaceWith);
    }
};

Array.prototype.remove = function(val) {
    var index = this.indexOf(val);
    if (index > -1) {
        this.splice(index, 1);
    }
};



function rand(s,e){
    return s + Math.floor(Math.random() * (e - s));
}

function log(obj){
    var str = "";
    if(obj instanceof  Array){
        for(var i = 0;i<obj.length;i++){
            str += obj[i] + ",";
        }
    }else if(obj instanceof  Object){
        for(var key in obj){
            str += key + ":" + obj[key] + "\n";
        }
    }else{
        if(arguments.length > 1){
            for(i =0 ;i<arguments.length;i++){
                str += arguments[i] + ","
            }
        }else{
            str = obj + "";
        }
    }
    if2d_fuc_Log(str + "");
}

function gameInput(title,msg,text,fuc){
    if2d_fuc_inputfuc = fuc;
    if2d_fuc_InputText(title,text,fuc);
}

function setWindowStatus(type){
}

function gameClose(){
    if2d_fuc_GameClose();
}


function IsPC() {
    return false;
}


function IMods(func){

    var mods = [];

    this.uis = {};

    var _sf = this;

    var rd = new IRWFile("iFMods");
    rd.onload = function(){
        rd.readMS(6);
        var l = rd.readInt();
        for(var i = 0;i<l;i++){
            var m = new IMod(rd);
            mods[m.key] = m;
            //跳过脚本
            var ll = rd.readInt();
            for(var j = 0 ; j < ll ; j++){
                rd.readString();
                rd.readString();
            }
            rd.readString();
            rd.readString();
            if(m.code >= 101){
                rd.readInt();
                _sf.uis[m.key] =new IModUI(rd, m.key);
            }
        }
        if(func != null){
            func();
        }
    };

    this.findMod = function(key){
        return mods[key];
    }

}

function IModUI(rd,mkey){
    this.code = rd.readInt();
    this.key = rd.readString();
    this.uis = {};
    this.ctrls = {};

    var length = rd.readInt();
    for(var i = 0;i<length;i++){
        var ui = new DUIMain(rd);
        this.uis[mkey + "_" + ui.id] = ui;
        ui.id = mkey + "_" + ui.id;
        changCtlrID(ui.ctrls,mkey);
    }

    length = rd.readInt();
    for(i = 0;i<length;i++){
        var ctrl = new DUISelfCtrl(rd);
        this.ctrls[mkey + "_" + ctrl.id] = ctrl;
        ctrl.id = mkey + "_" + ctrl.id;
    }

    function changCtlrID(ctrls,key){
        for(var i = 0;i<ctrls.length;i++){
            if(ctrls[i] instanceof DUICtrlItem){
                ctrls[i].id = key + "_" + ctrls[i].id;
            }
            if(ctrls[i] instanceof DUIGroup){
                ctrls[i].id = key + "_" + ctrls[i].id;
            }
            if(ctrls[i] instanceof  DUIView){
                changCtlrID(ctrls[i].ctrls,key);
            }
        }
    }
}

function IMod(rd){
    this.data = [];
    this.trigger = [];
    this.code = 100;

    var t = rd.readMS(5);
    if(t == "iFMOD"){
        this.code = rd.readInt();
    }else if(t == "iFMod"){
        this.code = 100;
    }
    rd.readString();rd.readString();rd.readString();rd.readInt();
    this.key = rd.readString();
    var l = rd.readInt();
    for (var i = 0; i < l; i++) {
        rd.readString();rd.readInt();rd.readBool();
    }
    rd.readBool();rd.readBool();rd.readBool();rd.readBool();rd.readBool();
    rd.readString();rd.readBool();rd.readInt();rd.readString();
    l = rd.readInt();
    for (i = 0; i < l; i++) {
        this.data.push(new IModData(rd));
    }
    l = rd.readInt();
    for (i = 0; i < l; i++) {
        var trig = new IModTrigger(rd,this.code);
        this.trigger[trig.key] = trig.js;
    }

    //跳过
    l = rd.readInt();
    for (i = 0; i < l; i++) {
        rd.readString();rd.readInt();rd.readBool();
    }
    rd.readString();
    //跳过
    l = rd.readInt();
    for (i = 0; i < l; i++) {
        rd.readString();
    }
    rd.readString();
    rd.readBool();rd.readBool();

    if(this.code >= 101){
        l = rd.readInt();
        for (i = 0; i < l; i++) {
            rd.readString();rd.readInt();rd.readBool();
        }
        l = rd.readInt();
        for (i = 0; i < l; i++) {
            rd.readString();rd.readInt();rd.readBool();
        }
    }
}

function IModData(rd){
    this.table = null;
    rd.readString();
    var temp = rd.readString();
    if(temp == "table"){
        this.table = [];
        var columns = rd.readInt();
        var rows = rd.readInt();

        for(var i = 0;i<rows;i++){
            var min = [];
            for(var j = 0;j<columns;j++){
                min[j] = rd.readString();
            }
            this.table.push(min);
        }
    }
    rd.readBool();
}

function IModTrigger(rd,code){
    rd.readString();

    this.key = rd.readString();
    this.js = rd.readString();

    rd.readMS(3);rd.readString();rd.readInt();rd.readInt();


    var l = rd.readInt();
    for (var i = 0; i < l; i++) {
        rd.readString();rd.readInt();rd.readString();
        if(code >= 101){
            rd.readString();
        }
    }
}
//文件 - IParticle.js
/**
 * Created by 七夕小雨 on 2016/11/9.
 */
function IParticle(bitmaps , num,tm,tp,viewport){
    var sprites = [];

    this.line = 0;
    this.dir = 0;
    this.rect = new IRect(0,0,10,10);

    this.radii = 10;

    this.x = 0;
    this.y = 0;

    var type = tp;
    var time = tm;

    var pos = 0;

    for(var i = 0;i<num;i++){
        sprites[i] = new ISprite(bitmaps[pos],viewport);
        sprites[i].x = this.rect.left + rand(0,this.rect.width);
        sprites[i].y = this.rect.top + rand(0,this.rect.height);
        sprites[i].opacity = 0;
        if(tp == 1){
            sprites[i].yx = 0.5;
            sprites[i].yy = 0.5;
        }
        pos = i % bitmaps.length;
    }

    this.changeParticle = function(bitmaps, num, tim, tp, viewport){
        for (var i = 0; i < sprites.length; i++) {
            sprites[i].disposeMin();
        }

        pos = 0;
        type = tp;
        time = tim;
        sprites = new Array(num);
        for (i = 0; i < sprites.length; i++) {
            sprites[i] = new ISprite(bitmaps[pos],viewport);
            sprites[i].x = this.rect.left + rand(0,this.rect.width);
            sprites[i].y = this.rect.top + rand(0,this.rect.height);
            sprites[i].opacity = 0;
            pos = i % bitmaps.length;
        }
    };

    Object.defineProperty(this, "z", {
        get: function () {
            return sprites[0].z;
        },
        set: function (value) {
            for (var i = 0; i < sprites.length; i++) {
                sprites[i].z = value;
            }
        }
    });

    this.dispose = function(){
        for (var i = 0; i < sprites.length; i++) {
            sprites[i].dispose();
        }
        sprites = null;
    };

    this.play = function(){
        if(sprites == null)return;
        for (var i = 0; i < sprites.length; i++) {
            if(sprites[i].isAnim()) continue;
            if(type == 0){
                var ftime = (time / 2)  + rand(0,time);
                sprites[i].opacity = 1.0;
                sprites[i].fadeTo(0, ftime);
                sprites[i].x = this.rect.left + rand(0,this.rect.width);
                sprites[i].y = this.rect.top + rand(0,this.rect.height);
                sprites[i].zoomY = sprites[i].zoomX = 1.0 - 0.5 * Math.random();
                switch (this.dir) {
                    case 0:
                        sprites[i].slideTo(sprites[i].x, sprites[i].y - this.line, ftime);
                        break;
                    case 1:
                        sprites[i].slideTo(sprites[i].x, sprites[i].y + this.line, ftime);
                        break;
                    case 2:
                        sprites[i].slideTo(sprites[i].x - this.line, sprites[i].y, ftime);
                        break;
                    case 3:
                        sprites[i].slideTo(sprites[i].x + this.line, sprites[i].y, ftime);
                        break;
                    case 4:
                        sprites[i].slideTo(sprites[i].x - this.line, sprites[i].y - this.line, ftime);
                        break;
                    case 5:
                        sprites[i].slideTo(sprites[i].x + this.line, sprites[i].y - this.line, ftime);
                        break;
                    case 6:
                        sprites[i].slideTo(sprites[i].x - this.line, sprites[i].y + this.line, ftime);
                        break;
                    case 7:
                        sprites[i].slideTo(sprites[i].x + this.line, sprites[i].y + this.line, ftime);
                        break;
                }
            }else if(type == 1){
                var d = rand(0,360);
                var angle = Math.PI * d  / 180.0;
                var endx = this.x + parseInt(Math.cos(angle) * this.radii);
                var endy = this.y + parseInt(Math.sin(angle) * this.radii);
                sprites[i].opacity = 1.0;
                sprites[i].angle = rand(0,360);
                ftime = (time / 2)  + rand(0,time);
                sprites[i].slide(this.x, this.y, endx, endy, ftime);
                sprites[i].fadeTo(0, ftime);
                sprites[i].zoomY = sprites[i].zoomX = 1.0 - 0.5 * Math.random();
                sprites[i].scaleTo(0.1, 0.1, ftime);
            }
        }
    };

    this.update = function(){
        this.play();
    }


}

//文件 - IPlane.js
/**
 * Created by 七夕小雨 on 2016/11/3.
 */

function IPlane(baseId,type){

    var _sf = this;

    this.fbox = null;
    var id = baseId;
    var tp = type;

    var x = 0;
    var y = 0;
    var z = 0;
    var zoomX = 1.0;
    var zoomY = 1.0;

    Object.defineProperty(this, "x", {
        get: function () {
            return x;
        },
        set: function (value) {
            setX(value);
        }
    });

    Object.defineProperty(this, "y", {
        get: function () {
            return y;
        },
        set: function (value) {
            setY(value);
        }
    });

    Object.defineProperty(this, "z", {
        get: function () {
            return z;
        },
        set: function (value) {
            setZ(value);
        }
    });

    Object.defineProperty(this, "zoomX", {
        get: function () {
            return zoomX;
        },
        set: function (value) {
            setZoomX(value);
        }
    });

    Object.defineProperty(this, "zoomY", {
        get: function () {
            return zoomY;
        },
        set: function (value) {
            setZoomY(value);
        }
    });

    function setX(xv){
        x = xv;
        if(tp == 2){
            if2d_viewport_setX(_sf.id,xv);
        }else{
            if2d_sprite_setX(_sf.id,xv);
        }

    }

    function setY(yv){
        y = yv;
        if(tp == 2){
            if2d_viewport_setY(_sf.id,yv);
        }else{
            if2d_sprite_setY(_sf.id,yv);
        }

    }

    function setZ(zv){
        z = zv;
        if(tp == 2){
            if2d_viewport_setZ(_sf.id,zv);
        }else{
            if2d_sprite_setZ(_sf.id,zv);
        }

    }

    function setZoomX(zx){
        zoomX = zx;
        if(tp == 2){
            if2d_viewport_setZoomX(_sf.id,zx);
        }else{
            if2d_sprite_setZoomX(_sf.id,zx);
        }

    }

    function setZoomY(zy){
        zoomY = zy;
        if(tp == 2){
            if2d_viewport_setZoomY(_sf.id,zy);
        }else{
            if2d_sprite_setZoomY(_sf.id,zy);
        }
    }

    var angle = 0;
    var opacity = 1.0;
    var visible = true;
    var mirror = false;

    Object.defineProperty(this, "angle", {
        get: function () {
            return angle;
        },
        set: function (value) {
            setAngle(value);
        }
    });

    Object.defineProperty(this, "opacity", {
        get: function () {
            return opacity;
        },
        set: function (value) {
            setOpacity(value);
        }
    });

    Object.defineProperty(this, "visible", {
        get: function () {
            return visible;
        },
        set: function (value) {
            setVisible(value);
        }
    });

    Object.defineProperty(this, "mirror", {
        get: function () {
            return mirror;
        },
        set: function (value) {
            setMirror(value);
        }
    });

    function setAngle(av){
        angle = av;
        if(tp == 2){
            if2d_viewport_setAngle(_sf.id,av);
        }else{
            if2d_sprite_setAngle(_sf.id,av);
        }

    }

    function setOpacity(ov){
        opacity = ov;
        if(tp == 2){
            if2d_viewport_setOpacity(_sf.id,ov);
        }else{
            if2d_sprite_setOpacity(_sf.id,ov);
        }
    }

    function setVisible(vv){
        visible = vv;
        if(tp == 2){
            if2d_viewport_setVisible(_sf.id,vv);
        }else{
            if2d_sprite_setVisible(_sf.id,vv);
        }

    }

    function setMirror(mv){
        mirror = mv;
        if(tp == 2){
            if2d_viewport_setMirror(_sf.id,mv);
        }else{
            if2d_sprite_setMirror(_sf.id,mv);
        }
    }

    this.tempZ = 0;
    this.wait = 0;
    this.actionList = [];
    this.tempActionList = [];
    this.actionLoop = false;

    this.color = IColor.Black();

    function setColor(){
        if(tp == 2){
            if2d_viewport_setColor(_sf.id , _sf.color.R / 255,_sf.color.G / 255,_sf.color.B / 255,_sf.color.A / 255);
        }else{
            if2d_sprite_setColor(_sf.id , _sf.color.R / 255,_sf.color.G / 255,_sf.color.B / 255,_sf.color.A / 255);
        }
    }

    //颜色相关
    var colorFrames = 0;
    var endColorA = 0;
    var diffColorA = 0;
    var tempColorA = 0;
    var tempColor = IColor.Transparent();
    //渐变相关
    var fadeFrames = 0;
    var endOpactiy = 0;
    var diffO = 0;
    var tmpOpacity = 0;
    //缩放相关
    var scaleFrames = 0;
    var endZoomX = 0;
    var endZoomY = 0;
    var diffZoomX = 0;
    var diffZoomY = 0;
    var tmpZoomX = 0;
    var tmpZoomY = 0;
    //位移相关
    var slideFrames = 0;
    var endX = 0;
    var endY = 0;
    var diffX = 0;
    var diffY = 0;
    var tmpX = 0;
    var tmpY = 0;
    //旋转相关
    var tmpRotateSpeed = 0;
    var tempAngel = 0.0;
    var endAngel = 0.0;
    var diffAngel = 0.0;
    var rotateFrames = 0.0;
    // 抛物线
    var tmpA = 0;
    var tmpB = 0;
    var tmpC = 0;
    var PstartX = 0;
    var diffPX = 0;
    var tmpPX = 0;
    var tmpYBase = 0;
    var LeftPX = false;
    var parabolaFrames = 0;

    this.tag = null;

    var pl = this;
    var isPause = false;

    var onEndAction;
    var onEndActionOne;
    var onEndFade;
    var onEndFlash;
    var onEndParabola;
    var onEndRotae;
    var onEndScale;
    var onEndSlide;
    var onEndWait;



    this.updatebase = function(){

        if(isPause) return;
        updateFlash();
        updateFade();
        updateScale();
        updateSlide();
        updateRotate();
        rotateUpdate();
        parabolaupdate();
        if(this.wait > 0){
            this.wait -= 1;
            if(this.wait <= 0){
                if(onEndWait != null){
                    onEndWait(pl);
                }
            }
            return;
        }
        if(this.actionList.length > 0){
            this.actionList[0].doThis();
            this.actionList.splice(0,1);
            if(onEndActionOne != null && this.actionList.length <= 0){
                onEndActionOne(pl);
            }
            if(this.actionList.length == 0){
                if(onEndAction != null && this.actionList.length <= 0){
                    onEndAction(pl);
                }
            }
        }
        if(this.actionLoop && this.actionList.length == 0){
            for(var i = 0;i<this.tempActionList.length;i++){
                var action = this.tempActionList[i];
                this.actionList.push(action);
            }
        }


    };

    this.endAction = function(){
        this.actionList = [];
        this.tempActionList = [];
        this.actionLoop = false;
    };
    
    this.isAnim = function () {
        return fadeFrames > 0 || slideFrames > 0 || scaleFrames > 0 || rotateFrames > 0 || this.wait > 0 || this.actionList.length > 0;
    };

    this.pauseAnim = function(){
        fadeFrames = 0;
        slideFrames = 0;
        scaleFrames = 0;
        rotateFrames = 0;
        colorFrames = 0;
        this.wait = 0;
        this.actionList = [];
        this.stopRotate();
    };

    this.pause = function () {
        isPause = true;
    };

    this.restart = function(){
        isPause = false;
    };

    this.isPause = function(){
        return isPause;
    };
    
    this.stopAnim = function () {
        if(fadeFrames > 0){
            fadeFrames = 0;
            this.opacity = endOpactiy;
        }
        if(slideFrames > 0){
            slideFrames = 0;
            this.x = endX;
            this.y = endY;
        }
        if(scaleFrames > 0){
            scaleFrames = 0;
            this.zoomX = endZoomX;
            this.zoomY = endZoomY;
        }
        if(rotateFrames > 0){
            rotateFrames = 0;
            this.angle = endAngel;
        }
        if(colorFrames > 0){
            colorFrames = 0;
            this.color.A = 0;
        }
        this.stopRotate();
    };


    this.fade = function(bOpacity,eOpacity,frames){
        if(frames <= 0){
            this.opacity = eOpacity;
        }else{
            fadeFrames = frames;
            endOpactiy = eOpacity;
            diffO = (eOpacity - bOpacity) /  parseFloat(frames);
            tmpOpacity = bOpacity;
            this.opacity = bOpacity;
        }
    };

    this.fadeTo = function (eOpacity, frames) {
        this.fade(this.opacity,eOpacity,frames);
    };

    function updateFade(){
        if(pl.visible == false || fadeFrames <=0) {
            return;
        }
        fadeFrames -= 1;
        if(fadeFrames <= 0){
            pl.opacity = endOpactiy;
            if(onEndFade != null && pl.actionList.length <= 0){
                onEndFade(pl);
            }
        }else{
            tmpOpacity += diffO;
            pl.opacity = tmpOpacity;
        }
    }


    this.slide = function(bX,bY,eX,eY,frames){
        if(frames <= 0){
            this.x = eX;
            this.y = eY;
        }else{
            slideFrames = frames;
            endX = eX;
            endY = eY;
            diffX = ((endX - bX) /  parseFloat(frames));
            diffY = (endY - bY) /  parseFloat(frames);
            tmpX = bX;
            tmpY = bY;
            this.x = bX;
            this.y = bY;
        }
    };

    this.slideTo = function (eX, eY, frames) {
        this.slide(this.x,this.y,eX,eY,frames);
    };

    function updateSlide(){
        if(slideFrames <= 0) return;
        slideFrames -= 1;
        if(slideFrames <= 0){
            pl.x = endX;
            pl.y = endY;
            if(onEndSlide != null && pl.actionList.length <= 0){
                onEndSlide(pl);
            }
        }else{
            tmpX += diffX;
            tmpY += diffY;
            pl.x = tmpX;
            pl.y = tmpY;
        }
    }


    this.scale = function(bzx,bzy,ezx,ezy,frames){
        if(frames <= 0){
            this.zoomX = bzx;
            this.zoomY = bzy;
        }else{
            scaleFrames = frames;
            endZoomX = ezx;
            endZoomY = ezy;
            diffZoomX = (endZoomX - bzx) / parseFloat(frames);
            diffZoomY = (endZoomY - bzy) /  parseFloat(frames);
            tmpZoomX = bzx;
            tmpZoomY = bzy;
            this.zoomX = bzx;
            this.zoomY = bzy;
        }
    };

    this.scaleTo = function(ezx,ezy,frames){
        this.scale(this.zoomX, this.zoomY, ezx, ezy, frames);
    };

    function updateScale(){
        if(scaleFrames <= 0) return;
        scaleFrames -= 1;
        if(scaleFrames <= 0){
            pl.zoomX = endZoomX;
            pl.zoomY = endZoomY;
            if(onEndScale != null && pl.actionList.length <= 0){
                onEndScale(pl);
            }
        }else{
            tmpZoomX += diffZoomX;
            tmpZoomY += diffZoomY;
            pl.zoomX = tmpZoomX;
            pl.zoomY = tmpZoomY;
        }
    }

    this.startRotate = function(speed){
        tmpRotateSpeed = speed;
    };

    this.stopRotate = function () {
        tmpRotateSpeed = 0;
    };

    function updateRotate(){
        if(tmpRotateSpeed == 0){
            return;
        }
        pl.angle = (pl.angle + tmpRotateSpeed) % 720;
    }

    /**
     * 旋转角度（推荐使用rotateTo方法）
     * @param bAngle 起始的旋转方法
     * @param eAngle 结束的旋转方法
     * @param frames 时间
     */
     this.rotate = function(bAngle, eAngle, frames){
        if(frames <= 0){
            this.angle = eAngle;
        }else{
            rotateFrames = frames;
            endAngel = eAngle;
            diffAngel = (eAngle - bAngle) / (frames * 1.0);
            if(diffAngel == 0) {
                diffAngel = 1;
                rotateFrames = 0;
            }
            tempAngel = bAngle;
            this.angle = bAngle;
        }
    };

    /**
     * 从当前角度旋转至某旋转
     * @param eAngle 结束的角度
     * @param frames 时间
     */
    this.rotateTo = function( eAngle, frames){
        this.rotate(this.angle, eAngle, frames);
    };

    function rotateUpdate(){
        if(rotateFrames <= 0) return;
        rotateFrames -= 1;
        if(rotateFrames <= 0){
            pl.angle = endAngel;
            if(onEndRotae != null && pl.actionList.length <= 0){
                onEndRotae(pl);
            }
        }else{
            tempAngel += diffAngel;
            pl.angle = tempAngel;
        }
    }

    /**
     * 精灵闪烁
     * @param color 闪烁颜色
     * @param frames 帧数
     */
    this.flash = function (color, frames) {
        if(frames <= 0){
            this.color = IColor.Black();
            setColor();
        }else{
            tempColor = color;
            this.color = color;
            this.color.A = parseInt(opacity * 255);
            colorFrames = frames;
            endColorA = 0;
            diffColorA = (endColorA - color.A) /  parseFloat(frames);
            tempColorA = color.A;
            setColor();
        }
    };

    function updateFlash(){
        if(colorFrames <= 0) return;
        colorFrames -= 1;
        if(colorFrames <= 0){
            pl.color = IColor.Black();
        }else{
            tempColorA += diffColorA;
            pl.color.R = tempColor.R * tempColorA / 255;
            pl.color.G = tempColor.G * tempColorA / 255;
            pl.color.B = tempColor.B * tempColorA / 255;
        }
        setColor();
    }


    /**
     * 抛物线
     * 可以添加参数自行测试
     * @param xRoat X轴斜率（>0朝下，<0朝上  推荐绝对值|0.1~0.05|的参数）
     * @param height 抛物线高度
     * @param frames 完成抛物线所需的时间
     * @param left 左右朝向 true：左 false 右
     * @param cycle 周期1为一个周期 2为2个周期（从A1点到A2为一个周期，如果还需要继续往下坠落需要增加周期）
     */
    this.parabola = function( xRoat, height, frames, left, cycle){
        tmpA = xRoat;
        tmpB = height;
        tmpC = this.y;
        PstartX = -1 * Math.sqrt(tmpB / tmpA);
        LeftPX = left;
        parabolaFrames = frames;
        tmpPX = -Math.abs(PstartX);
        diffPX = (Math.abs(PstartX) * (2 + cycle)) / parabolaFrames;
        tmpYBase = (tmpA * tmpPX * tmpPX + tmpB);
    };

    function parabolaupdate(){
        if(parabolaFrames <= 0) return;
        parabolaFrames -= 1;
        if(parabolaFrames <= 0){
            if(onEndParabola != null && pl.actionList.length <= 0){
                onEndParabola(pl);
            }
        }
        tmpPX += diffPX;
        var tmpY = (int) ((tmpA * tmpPX * tmpPX + tmpB) - tmpYBase);
        if(LeftPX){
            pl.x += diffPX;
        }else{
            pl.x -= diffPX;
        }
        pl.y = tmpC + tmpY;
    }


    this.addAction = function(){
        var action = new actionDo(arguments);
        this.actionList.push(action);
        this.tempActionList.push(action);
    };

    function actionDo(){
        var argmen = arguments[0];
        var ac = argmen[0];
        var args = [];
        for(var i = 1;i<argmen.length;i++){
            args[i - 1] = argmen[i];
        }

        this.doThis = function(){
            switch (ac){
                case 4:
                    pl.wait = args[0];
                    break;
                case 2:
                    if(args.length == 3){
                        pl.slideTo(args[0],args[1],args[2]);
                    }else if(args.length == 5){
                        pl.slide(args[0],args[1],args[2],args[3],args[4])
                    }
                    break;
                case 5:
                    if(args.length == 3){
                        pl.scaleTo(args[0],args[1],args[2]);
                    }else if(args.length == 5){
                        pl.scale(args[0],args[1],args[2],args[3],args[4])
                    }
                    break;
                case 1:
                    if(args.length == 2){
                        pl.fadeTo(args[0],args[1]);
                    }else if(args.length == 3){
                        pl.fade(args[0],args[1],args[2])
                    }
                    break;
                case 3:
                    if(args.length == 1){
                        pl.startRotate(args[0]);
                    }else if(args.length == 2){
                        pl.rotateTo(args[0],args[1])
                    }else if(args.length == 3){
                        pl.rotate(args[0],args[1],args[2])
                    }
                    break;
                default :
                    break;
            }
        }
    }


    this.setOnEndSlide = function(e){
        onEndSlide = e;
    };

   this.setOnEndFade = function(e){
        onEndFade = e;
    };

    this.setOnEndScale = function(e){
        onEndScale = e;
    };

    this.setOnEndRotae = function(e){
        onEndRotae = e;
    };

    this.setOnEndFlash = function(e){
        onEndFlash = e;
    };

    this.setOnEndParabola = function(e){
        onEndParabola = e;
    };

   this.setOnEndActionOne = function(e){
        onEndActionOne = e;
    };

    this.setOnEndAction = function(e){
        onEndAction = e;
    };

    this.setOnEndWait = function(e){
        onEndWait = e;
    }

}

var action = {
    fade:1,
    move:2,
    rotate:3,
    wait:4,
    zoom:5
};

//文件 - IRect.js
/**
 * Created by 七夕小雨 on 2016/11/4.
 */

function IRect(l,t,r,b){

    var _sf = this;

    this.left = l;
    this.top = t;
    this.right = r;
    this.bottom = b;

    Object.defineProperty(this,"centerX",{
        get:function(){
            return parseInt(_sf.left + _sf.width / 2);
        }
    });

    Object.defineProperty(this,"centerY",{
        get:function(){
            return parseInt(_sf.top + _sf.height / 2);
        }
    });

    Object.defineProperty(this, "x", {
        get: function () {
            return _sf.left;
        },
        set: function (value) {
            var w = _sf.width;
            _sf.left = value;
            _sf.right = value + w;
        }
    });

    Object.defineProperty(this, "y", {
        get: function () {
            return _sf.top;
        },
        set: function (value) {
            var h = _sf.height;
            _sf.top = value;
            _sf.bottom = value + h;
        }
    });

    Object.defineProperty(this,"width",{
        get : function(){
            return _sf.right - _sf.left;
        },
        set : function(value){
            _sf.right = _sf.left + value;
            _sf.centerX = (_sf.left + (_sf.right - _sf.left)) / 2;
        }
    });

    Object.defineProperty(this,"height",{
        get : function(){
            return _sf.bottom - _sf.top;
        },
        set : function(value){
            _sf.bottom = _sf.top + value;
            _sf.centerY = (_sf.top + (_sf.bottom - _sf.top)) / 2;
        }
    });


    this.intersects = function(){
        var r = null;
        if(arguments.length == 1){
            r = arguments[0];
        }else if(arguments.length == 4){
            r = new IRect(arguments[0],arguments[1],arguments[2],arguments[3]);
        }
        if(r == null){
            return false;
        }

        var r1 = r;
        var r2 = this;

        return !(r1.left > r2.right || r1.top > r2.bottom || r2.left > r1.right || r2.top > r1.bottom);
    };

    this.contains = function(){
        var r = null;
        if(arguments.length == 1){
            r = arguments[0];
        }else if(arguments.length == 4){
            r = new IRect(arguments[0],arguments[1],arguments[2],arguments[3]);
        }
        //如果要包含就要看看谁比较大了,如果都没有大的就包含失败
        var thisbig = false;
        if(this.width >= r.width && this.height >= r.height){
            thisbig = true;
        }else if(r.width >= this.width && r.height >= this.right){
            thisbig = false;
        }else{
            r = null;
        }
        if(r != null){
            if(thisbig){
                return r.left >= this.left && r.right <= this.right && r.top >= this.top && r.bottom >= this.bottom;
            }else{
                return this.left >= r.left && this.right <= r.right && this.top >= r.top && this.bottom >= r.bottom;
            }
        }

        if(r == null){
            return false;
        }
    };


    function pointIsIn(x,y,r){
        return x >= r.left && x <= r.right && y>= r.top && y <= r.bottom;
    }


}
//文件 - IRWFile.js
/**
 * Created by 七夕小雨 on 2016/11/8.
 */

function IRWFile(file,type,code,tag){
    if(file == undefined){
        throw new Error('IRWFile 实例化失败 file为空');
    }
    if(type == null){
        type = 0;
    }

    var _sf = this;

    this.id = -1;

    this.loadText = "";

    var irw = this;



    if(type == 0){
        this.id = if2d_rwfile_creatRWFIle(file);
    }else{
        this.loadText = if2d_rwfile_LoadFile(file);
    }

    Object.defineProperty(this, "onload", {
        set: function (fc) {
            if(type == 0){
                fc();
            }else{
                fc(_sf.loadText,tag);
            }
        }
    });

    this.readShort = function(){
        return if2d_rwfile_readShort(this.id);
    };

    this.readInt = function(){
        return if2d_rwfile_readInt(this.id);
    };

    this.readLong = function(){
        return if2d_rwfile_readLong(this.id);
    };

    this.readString = function(){
        return if2d_rwfile_readString(this.id);
    };

    this.readBool = function(){
        return if2d_rwfile_readBool(this.id);
    };

    this.readMS = function (length) {
        return if2d_rwfile_readMS(this.id,length)
    };

    this.getPos = function(){
        return if2d_rwfile_getPos(this.id);
    };

    function stringToBytes ( str ) {
        var ch, st, re = [];
        for (var i = 0; i < str.length; i++ ) {
            ch = str.charCodeAt(i);
            st = [];
            do {
                st.push( ch & 0xFF );
                ch = ch >> 8;
            }
            while ( ch );
            re = re.concat( st.reverse() );
        }
        return re;
    }

}


IRWFile.SaveKV = function(key,value){
    if2d_rwfile_WriteFile(key , JSON.stringify(value));
};

IRWFile.LoadKV = function(key){
    try{
        return JSON.parse(if2d_rwfile_LoadFile(key));
    }catch(e){
        return null;
    }
};
//文件 - IScrollbar.js
/**
 * Created by 七夕小雨 on 2016/11/8.
 */

function IScrollbar( bmp1, bmp2, v, m,vp,bmp3,icon){

    var viewport = null;
    var viewprotMiddle = null;
    var image = [];
    var back = null;
    var top = null;
    var middle = null;
    var iconS = null;

    var iconDx = 0;
    var iconDy = 0;
    var value = 0;
    var value2 = 0;
    this.dir = 0;

    var tempValue = -1;
    var tempValue2 = -1;
    var valueType = 0;
    var tempMax = 0;
    var max = 0;

    var tmpValue = 0;
    var endValue = 0;
    var diffValue = 0;
    var valueFrames = 0;

    this.tag = null;
    var sb = this;

    if(bmp1 == undefined || bmp2 == undefined) return;
    if(bmp1 == null || bmp2 == null) return;
    image = [bmp1,bmp2];
    value = v || 0;
    max = m || 100;


    viewport = new IViewport(0, 0, image[0].width, image[0].height + 5,vp);
    viewprotMiddle = new IViewport(0, 0, image[0].width, image[0].height + 5,vp);
    back = new ISprite(image[0],vp);
    top = new ISprite(image[1],viewport);

    if(bmp3 != null){
        middle = new ISprite(bmp3,viewprotMiddle);
    }
    if(icon != null){
        iconS = new ISprite(icon,vp)
    }

    if(image[1].complete){
        viewport.width = image[1].width;
        viewport.height = image[1].height + 5;
        viewprotMiddle.width = image[1].width;
        viewprotMiddle.height = image[1].height;
        top.width = image[1].width;
        top.height = image[1].height;
        top.onload = function(){};
        reDrawBar();

    }else{
        image[1].onload = function(){
            viewport.width = image[1].width;
            viewport.height = image[1].height + 5;
            viewprotMiddle.width = image[1].width;
            viewprotMiddle.height = image[1].height;
            top.width = image[1].width;
            top.height = image[1].height;
            top.onload = function(){};
            reDrawBar();
        }
    }

    Object.defineProperty(this, "onload", {
        set: function (fc) {
            back.onload = function(){
                fc(sb);
            }
        }
    });

    reDrawBar();

    this.setIconPoint = function(dx,dy){
        iconDx = dx;
        iconDy = dy;
        sb.setX(sb.getX());
        sb.setY(sb.getY());
    };

    this.setX = function(x){
        back.x = x;
        viewport.x = x;
        if(middle != null){
            viewprotMiddle.x = x;
        }
        if(iconS != null){
            iconS.x = x + iconDx;
        }
    };

    this.getX = function(){
        return back.x;
    };

    this.setY = function(y){
        back.y = y;
        viewport.y = y;
        if(middle != null){
            viewprotMiddle.y = y;
        }
        if(iconS != null){
            iconS.y = y + iconDy;
        }
    };

    this.getY = function(){
        return back.y;
    };

    this.setZ = function(z){
        back.z = z;
        top.z = z + 3;
        viewport.z = z + 3;
        if(middle != null){
            viewprotMiddle.z = z + 2;
        }
        if(iconS != null){
            iconS.z = z + 5;
        }
    };



    Object.defineProperty(this, "x", {
        get: function () {
            return back.x;
        },
        set: function (value) {
            sb.setX(value);

        }
    });

    Object.defineProperty(this, "y", {
        get: function () {
            return back.y;
        },
        set: function (value) {
            sb.setY(value);

        }
    });

    Object.defineProperty(this, "z", {
        get: function () {
            return back.z;
        },
        set: function (value) {
            sb.setZ(value);
        }
    });

    Object.defineProperty(this, "zoomX", {
        get: function () {
            return back.zoomX;
        },
        set: function (value) {
            back.zoomX = value;
            if(viewport != null) viewport.zoomX = value;
            if(middle != null){
                middle.zoomX = value;
            }
            if(iconS != null){
                iconS.zoomX = value;
            }
        }
    });

    Object.defineProperty(this, "zoomY", {
        get: function () {
            return back.zoomY;
        },
        set: function (value) {
            back.zoomY = value;
            if(viewport != null) viewport.zoomY = value;
            if(middle != null){
                middle.zoomY = value;
            }
            if(iconS != null){
                iconS.zoomY = value;
            }

        }
    });

    Object.defineProperty(this, "visible", {
        get: function () {
            return back.visible;
        },
        set: function (value) {
            back.visible = value;
            if(viewport != null) viewport.visible = value;
            if(middle != null){
                middle.visible = value;
            }
            if(iconS != null){
                iconS.visible = value;
            }

        }
    });

    Object.defineProperty(this, "opacity", {
        get: function () {
            return back.opacity;
        },
        set: function (value) {
            sb.setOpactiy(value);
        }
    });

    Object.defineProperty(this, "width", {
        get: function () {
            return back.width;
        },
        set: function (value) {}
    });

    Object.defineProperty(this, "height", {
        get: function () {
            return back.height;
        },
        set: function (value) {}
    });

    this.width = function(){
        return back.width;
    };

    this.height = function(){
        return back.height;
    };

    this.setOpactiy = function(o){
        back.opacity = o;
        top.opacity = o;
        if(middle != null){
            middle.opacity = o;
        }
        if(iconS != null){
            iconS.opacity = o;
        }
    };

    this.fade = function(bo, eo, frame){
        back.fade(bo,eo,frame);
        if(top != null) top.fade(bo,eo,frame);
        if(viewprotMiddle != null) viewprotMiddle.fade(bo,eo,frame);
        if(iconS != null) iconS.fade(bo,eo,frame);
    };

    this.fadeTo = function(o, frame){
        back.fadeTo(o, frame);
        if(top != null) top.fadeTo(o, frame);
        if(viewprotMiddle != null) viewprotMiddle.fadeTo(o, frame);
        if(iconS != null) iconS.fadeTo(o, frame);
    };

    this.slide = function(bx, by,ex,ey, frame){
        back.slide(bx,by,ex,ey,frame);
        if(viewport != null) viewport.slide(bx,by,ex,ey,frame);
        if(viewprotMiddle != null) viewprotMiddle.slide(bx,by,ex,ey,frame);
        if(iconS != null) iconS.slide(bx,by,ex,ey,frame);
    };

    this.slideTo = function( x, y, frame){
        back.slideTo(x, y, frame);
        if(viewport != null) viewport.slideTo(x , y , frame);
        if(viewprotMiddle != null) viewprotMiddle.slideTo(x , y , frame);
        if(iconS != null) iconS.slideTo(x , y , frame);
    };

    this.scale = function( bzx, bzy,ezx,ezy, frame){
        back.scale(bzx,bzy,ezx,ezy,frame);
        if(viewport != null) viewport.scale(bzx,bzy,ezx,ezy,frame);
        if(viewprotMiddle != null) viewprotMiddle.scale(bzx,bzy,ezx,ezy,frame);
        if(iconS != null) iconS.scale(bzx,bzy,ezx,ezy,frame);
    };

    this.scaleTo = function( zx, zy, frame){
        back.scaleTo(zx, zy, frame);
        if(viewport != null) viewport.scaleTo(zx ,zy , frame);
        if(viewprotMiddle != null) viewprotMiddle.scaleTo(zx ,zy , frame);
        if(iconS != null) iconS.scaleTo(zx ,zy , frame);
    };

    this.setAction = function(action,args){
        back.addAction.apply(back,arguments);
        if(viewport != null) viewport.addAction.apply(viewport,arguments);
        if(viewprotMiddle != null) viewprotMiddle.addAction.apply(viewprotMiddle,arguments);
        if(iconS != null) iconS.addAction.apply(iconS,arguments);
    };

    this.setActLoop = function( loop){
        back.actionLoop = loop;
        if(viewport != null) viewport.actionLoop = loop;
        if(viewprotMiddle != null) viewprotMiddle.actionLoop = loop;
        if(iconS != null) iconS.actionLoop = loop;
    };

    this.getActLoop = function(){
        return back.actionLoop;
    };

    this.dispose = function(){
        this.disposeMin();
        viewport.dispose();
        viewprotMiddle.dispose();
        if(image[0] != null) {
            image[0] = null;
        }
        if(image[1] != null) {
            image[1] = null;
        }
        image = [];
    };

    this.disposeMin = function(){
        back.disposeMin();
        top.disposeMin();
        if(middle != null){
            middle.disposeMin();
        }
        if(iconS != null){
            iconS.disposeMin();
        }
    };

    this.setValue = function( val, m){
        value = val;
        max = m;
    };

    this.isClick = function(){
        if(!back.visible){
            return false;
        }
        var f = IInput.up && back.isSelect();
        if(f){
            IInput.up = false;
        }
        return f;
    };

    this.update = function () {
        if(!back.visible) return;
        updateValueAnim();
        reDrawBar();
        reDrawMiddleBar();
    };

    this.touchValue = function(){
        if(IInput.y > back.y && IInput.y <= back.y + back.height && IInput.x >= back.x && IInput.x <= back.x + back.width){
            value = (IInput.x - back.x) * max / back.width
        }
    };

    this.valueAnim = function( bValue, eValue, frames){
        if(bValue > eValue){
            valueType = 1;
            value = eValue;
            if(frames <= 0){
                value2 = eValue;
            }else{
                valueFrames = frames;
                endValue = eValue;
                diffValue = (eValue - bValue) / (frames);
                tmpValue = bValue;
                value2 = bValue;
            }
        }else{
            valueType = 0;
            value2 = eValue;
            if(frames <= 0){
                value = eValue;
            }else{
                valueFrames = frames;
                endValue = eValue;
                diffValue = (eValue - bValue) / (frames);
                tmpValue = bValue;
                value = bValue;
            }
        }

    };

    this.valueAnimTo = function( eValue, frames){
        this.valueAnim(value,eValue,frames);
    };

    function updateValueAnim(){
        if(valueFrames <= 0) return;
        valueFrames -= 1;
        if(valueType == 0){
            if(valueFrames <= 0){
                value = endValue;
            }else{
                tmpValue += diffValue;
                value = parseInt(tmpValue);
            }
        }else if(valueType == 1){
            if(valueFrames <= 0){
                value2 = endValue;
            }else{
                tmpValue += diffValue;
                value2 = parseInt(tmpValue);
            }
        }

    }

    function reDrawBar(){
        if(top.height == 0 && top.width == 0) return;
        if(tempValue != value || tempMax != max){
            tempMax = max;
            tempValue = value;
            var zt = Math.min(max,value);
            if(sb.dir == 1){
                viewport.x = parseInt(back.x + top.width -  ((top.width * zt) / max));
                viewport.ox = parseInt(-(top.width - (top.width * zt) / max));
                viewport.width = parseInt((top.width * zt) / max);
            }else if(sb.dir == 2){
                viewport.width = top.width;
                viewport.height = parseInt((top.height * zt / max));
            }else if(sb.dir == 3){
                viewport.width = top.width;
                viewport.y = parseInt(back.y + top.height -  ((top.height * zt) / max));
                viewport.oy = parseInt(-(top.height -  ((top.height * zt) / max)));
                viewport.height = parseInt((top.height * zt) / max);
            }else{
                viewport.width = parseInt((top.width * zt) / max);
            }
        }
    }

    function reDrawMiddleBar(){
        if(top.height == 0 && top.width == 0) return;
        if(tempValue2 != value2 || tempMax != max){
            tempMax = max;
            tempValue2 = value2;
            var zt = Math.min(max,value2);
            if(sb.dir == 1){
                viewprotMiddle.x = parseInt(back.x + top.width -  ((top.width * zt) / max));
                viewprotMiddle.ox = parseInt(-(top.width - (top.width * zt) / max));
                viewprotMiddle.width = parseInt((top.width * zt) / max);
            }else if(sb.dir == 2){
                viewprotMiddle.width = top.width;
                viewprotMiddle.height = parseInt((top.height * zt / max));
            }else if(sb.dir == 3){
                viewprotMiddle.width = top.width;
                viewprotMiddle.y = parseInt(back.y + top.height -  ((top.height * zt) / max));
                viewprotMiddle.oy = parseInt(-(top.height -  ((top.height * zt) / max)));
                viewprotMiddle.height = parseInt((top.height * zt) / max);
            }else{
                viewprotMiddle.width = parseInt((top.width * zt) / max);
            }
        }
    }
}

IScrollbar.Dir = {
    Left : 0,
    Right : 1,
    Down : 2,
    Up : 3
};
//文件 - ISound.js
/**
 * Created by 七夕小雨 on 2018-1-26.
 */
function ISound(p,v){
    var path =p;
    var volume = v;

    this.play = function(){
        if(path == undefined || path.length <= 0) return;
        IAudio.playSE(path,v);
    }
}
//文件 - ISprite.js
/**
 * Created by 七夕小雨 on 2016/11/3.
 */

function ISprite(bitmap,vp){

    this.id = -1;
    this.width = 0;
    this.height = 0;
    var tyy = 0;
    var tyx = 0;
    var tRWidth = 0;
    var tRHeight = 0;
    var image = null;
    var bCof = null;
    var ttiling = false;
    this.viewport = null;
    var activity = false;

    var speedX = 0;
    var speedY = 0;
    var aSpeedX = 0;
    var aSpeedY = 0;

    var _sf = this;

    var canDraw = false;

    var touchId = -2;
    var isTouch = false;
    var lineSpacing = 1.2;

    var rect = new IRect(1,1,1,1);

    Object.defineProperty(this, "tiling", {
        get: function () {
            return ttiling;
        },
        set: function (value) {
            setTiling(value);
        }
    });

    Object.defineProperty(this, "RWidth", {
        get: function () {
            return tRWidth;
        },
        set: function (value) {
            setRWidth(value);
        }
    });

    Object.defineProperty(this, "RHeight", {
        get: function () {
            return tRHeight;
        },
        set: function (value) {
            setRHeight(value);
        }
    });


    Object.defineProperty(this, "yy", {
        get: function () {
            return tyy;
        },
        set: function (value) {
            setYY(value);
        }
    });

    Object.defineProperty(this, "yx", {
        get: function () {
            return tyx;
        },
        set: function (value) {
            setYX(value);
        }
    });

    Object.defineProperty(this, "speedX", {
        get: function () {
            return speedX;
        },
        set: function (value) {
            setSpeedX(value);
        }
    });

    Object.defineProperty(this, "speedY", {
        get: function () {
            return speedY;
        },
        set: function (value) {
            setSpeedY(value);
        }
    });

    Object.defineProperty(this, "aSpeedX", {
        get: function () {
            return aSpeedX;
        },
        set: function (value) {
            setASpeedX(value);
        }
    });

    Object.defineProperty(this, "aSpeedY", {
        get: function () {
            return aSpeedY;
        },
        set: function (value) {
            setASpeedY(value);
        }
    });

    Object.defineProperty(this, "lineSpacing",{
        get : function(){
            return lineSpacing;
        },
        set : function(value){
            setLineSpacing(value);
        }
    });

    Object.defineProperty(this, "onload", {
        set: function (fc) {
            fc(_sf);
        }
    });

    if(arguments.length >= 3){//根据尺寸创建
        var ccolor = arguments[2];
        this.id = if2d_sprite_creatISpriteSize(parseInt(arguments[0]) ,parseInt(arguments[1]) , parseInt(ccolor.R) , parseInt(ccolor.G) , parseInt(ccolor.B) , parseInt(ccolor.A));
        this.width = parseInt(arguments[0]);
        this.height = parseInt(arguments[1]);
        IVal.Box.add(this);
    }else {
        var vpid = -1;
        if (vp != undefined && vp instanceof  IViewport) {
            this.viewport = vp;
            this.viewport.add(this);
            vpid = vp.id;
        }
        if(bitmap instanceof  IBCof){
            bCof = bitmap;
            this.id = if2d_sprite_creatISpriteBCof(bCof.id,vpid);
            image = bCof.bitmap;
            this.width = bCof.width;
            this.height = bCof.height;

            if(this.viewport == null) IVal.Box.add(this);
        }else{
            image = bitmap;
            this.id = if2d_sprite_creatISpriteBitmap(image.id,vpid);
            this.width = image.width;
            this.height = image.height;
            if(this.viewport == null) IVal.Box.add(this);
        }

    }

    this.plane = IPlane;
    this.plane(this.id,1);
    delete this.plane;

    function setTiling(value){
        ttiling = value;
        if2d_sprite_setTiling(_sf.id,value);
    }

    function setRWidth(value){
        tRWidth = value;
        if2d_sprite_setRWidth(_sf.id,value);
    }

    function setRHeight(value){
        tRHeight = value;
        if2d_sprite_setRHeight(_sf.id,value);
    }

    function setYY(value){
        tyy = value;
        if2d_sprite_setYY(_sf.id,value);
    }

    function setYX(value){
        tyx = value;
        if2d_sprite_setYX(_sf.id,value);
    }

    function setSpeedX(value){
        speedX = value;
        if2d_sprite_setSpeedX(_sf.id,value);
    }

    function setSpeedY(value){
        speedY = value;
        if2d_sprite_setSpeedY(_sf.id,value);
    }

    function setASpeedX(value){
        speedX = value;
        if2d_sprite_setASpeedX(_sf.id,value);
    }

    function setASpeedY(value){
        speedY = value;
        if2d_sprite_setASpeedY(_sf.id,value);
    }

    function setLineSpacing(value){
        lineSpacing = value;
        if2d_sprite_setLineSpacing(_sf.id,value);
    }

    this.ListToImage = function(){
    };

    this.clearBitmap = function(){
        if2d_sprite_clearBitmap(_sf.id);
    };


    this.setXY = function (inx, iny) {
        this.x = inx;
        this.y = iny;
    };

    this.isSelect = function (x,y) {
        if(bCof != null){
            this.width = bCof.width;
            this.height = bCof.height;
        }
        var nowX = x;
        var nowY = y;
        var spX = this.x - (this.width * this.yx * this.zoomX);
        var spY = this.y - (this.height * this.yy * this.zoomY);
        if(this.viewport == null){
            return nowX > spX && nowX <= spX + (this.width * this.zoomX) && nowY > spY && nowY <= spY + (this.height * this.zoomY);
        }else{
            if(nowX >= this.viewport.x && nowX <= this.viewport.width + this.viewport.x &&
             nowY >= this.viewport.y && nowY <= this.viewport.height + this.viewport.y){
                var tx = this.viewport.x + this.viewport.ox + spX;
                var ty = this.viewport.y + this.viewport.oy + spY;
                return nowX > tx && nowX <= tx + (this.width * this.zoomX) && nowY > ty && nowY <= ty + (this.height * this.zoomY);
            }else{
                return false;
            }
        }
    };

    this.isSelected = function(){
        return this.isSelect(IInput.x,IInput.y);
    };

    this.isSelectTouch = function(){
        var oldPoint = false;
        for(var i = 0;i<IInput.touches.length;i++){
            if(this.isSelect(IInput.touches[i].clientX,IInput.touches[i].clientY)){
                touchId = IInput.touches[i].id;
                isTouch = true;
                return 1;
            }
            if(IInput.touches[i].id == touchId){
                isTouch = false;
                oldPoint = true;
            }
        }
        if(isTouch && oldPoint == false){
            isTouch = false;
            touchId = -2;
            return 2;//抬起
        }
        isTouch = false;
        return 0;

    };

    this.drawRect = function(rect,color){
        if2d_sprite_drawRect(_sf.id , parseInt(rect.x) , parseInt(rect.y) , parseInt(rect.width) , parseInt(rect.height),color.R,color.G,color.B,color.A);
    };

    this.drawTextQ = function(s,x,y,color,size){
        if2d_sprite_drawTextQ(_sf.id , s +"",parseInt(x) , parseInt(y) , color.R , color.G , color.B , color.A , parseInt(size));
    };

    this.drawText = function (str, x, y, type, wcolor , isAutoL, size) {
        if(x == null){
            x = 0;
        }
        if(y == null){
            y = 0
        }
        if(type == null){
            type = 0;
        }
        if(wcolor == null){
            wcolor = IColor.Black();
        }
        if(isAutoL == null){
            isAutoL = false;
        }
        if(size == null){
            size = 0;
        }
        if2d_sprite_drawText(_sf.id , str +"",type, parseInt(x), parseInt(y),wcolor.R,wcolor.G,wcolor.B,wcolor.A,isAutoL,parseInt(size));
    };

    this.drawBitmap = function(bmp, x, y, isDispose){
        if(isDispose == null) isDispose = false;
        if2d_sprite_drawBitmap(_sf.id,bmp.id , x ,y , isDispose);
    };

    this.drawBitmapRect = function(bmp,rect,isDispose){
        if(isDispose == null) isDispose = false;
        if2d_sprite_drawBitmapRect(_sf.id,bmp.id, rect.x, rect.y,rect.width,rect.height,isDispose);
    };

    this.drawBitmapBCof = function(x,y,bcof,isDispose){
        if(isDispose == null) isDispose = false;
        if2d_sprite_drawBitmapBCof(_sf.id , bcof.id , x , y ,isDispose);
    };

    this.getBitmap = function(){
        return image;
    };


    this.dispose = function(){
        this.disposeBitmap();
        this.disposeMin();
    };

    this.disposeMin = function () {

        if2d_sprite_disposeMin(_sf.id );
        if(_sf.viewport != null){
            _sf.viewport.zbox.remove(_sf);
        }else{
            IVal.Box.remove(_sf);
        }
    };

    this.disposeBitmap = function () {
        if2d_sprite_disposeBitmap(_sf.id );
    };


    this.setBCof = function(bcof){
        bCof = bcof;
        if2d_sprite_setBCof(_sf.id , bcof.id);
        image = bCof.bitmap;
        this.width = bCof.width;
        this.height = bCof.height;
    };

    this.getBCof = function(){
        return bCof;
    };

    this.setBitmap = function(bitmap){
        if2d_sprite_setBitmap(_sf.id , bitmap.id);
        image = bitmap;
        this.width = bitmap.width;
        this.height = bitmap.height;
    };

    this.GetRect = function() {
        if(bCof != null){
            this.width = bCof.width;
            this.height = bCof.height;
        }
        var spX = this.x - (this.width * this.yx * this.zoomX);
        var spY = this.y - (this.height * this.yy * this.zoomY);

        rect.left = spX;
        rect.top = spY;
        rect.right = spX + (this.width * this.zoomX);
        rect.bottom = spY + (this.height * this.zoomY);

        return rect;
    };

    this.update = function(){
        this.updatebase();
    };

    this.updateBitmap = function(){
    }
}

ISprite.toRegular = function(s){
    var str = s;
    for(var key in IVal.regularList){
        var vl = IVal.regularList[key];
        str = str.replaceAll(key,vl);
    }
    return str;
};

ISprite.getDrawTextSize = function(str,isAutoL, size,ls){
    if(ls == null) ls = 1.2;
    var v = if2d_sprite_getDrawTextSize(str,isAutoL, size,ls);
    var vs = v.split(",");
    return {width : parseFloat(vs[0]) , height : parseFloat(vs[1])};
};

//文件 - IVal.js
/**
 * Created by 七夕小雨 on 2016/11/3.
 */

function IVal() {

}
IVal.FPS = 60;
IVal.GWidth = 0;
IVal.GHeight = 0;
IVal.startScene = null;
IVal.scene = null;
IVal.FontColor = IColor.White();
IVal.FontSize = 18;
IVal.DEBUG = false;
IVal.FontName = "微软雅黑";
IVal.dSound = null;
IVal.regularList = {};
IVal.baseMusicPath = "";
IVal.baseBPath = "";
IVal.updateNumSp = 0;
IVal.Platform = "Windows";
IVal.Box = null;
IVal.Mods = null;
//文件 - IViewport.js
/**
 * Created by 七夕小雨 on 2016/11/4.
 */

function IViewport(x,y,w,h,viewport){

    this.id = 0;

    var width = 0;
    var height = 0;
    var ox = 0;
    var oy = 0;

    this.dir = IViewport.Dir.None;
    var type = IViewport.Type.Rectangle;
    var radius = w / 2;
    this.isAutoMove = false;
    this.endPosDX = 0;
    this.endPosDY = 0;

    var endPosX = 0;
    var endPosY = 0;
    var tmpOX = 0;
    var tmpOY = 0;
    var endOX = 0;
    var endOY = 0;
    var diffOX = 0;
    var diffOY = 0;
    var OFrames = 0;

    var isMove = false;
    var reMove = false;
    var isMove_l = false;
    var reMove_l = false;

    var rect = new IRect(1,1,1,1);

    var vpid = -1;
    this.fviewporte = viewport;
    if(this.fviewporte != null){
        vpid = this.fviewporte.id;
        this.fviewporte.add(this);
    }else{
        IVal.Box.add(this);
    }
    this.id = if2d_viewport_creatView(x,y,w,h,vpid);

    width = w;
    height = h;
    var vp = this;

    this.zbox = new IBox();

    this.plane = IPlane;
    this.plane(this.id,2);
    delete this.plane;

    vp.x = x;
    vp.y = y;
    var tempX = 0;
    var tempY = 0;

    this.add = function(value){
        this.zbox.add(value);
    };

    Object.defineProperty(this, "type", {
        get: function () {
            return type;
        },
        set: function (value) {
            setType(value);
        }
    });

    Object.defineProperty(this, "radius", {
        get: function () {
            return radius;
        },
        set: function (value) {
            setRadius(value);
        }
    });

    Object.defineProperty(this, "width", {
        get: function () {
            return width;
        },
        set: function (value) {
            setWidth(value);
        }
    });

    Object.defineProperty(this, "height", {
        get: function () {
            return height;
        },
        set: function (value) {
            setHeight(value);
        }
    });

    Object.defineProperty(this, "ox", {
        get: function () {
            return ox;
        },
        set: function (value) {
            setOX(value);
        }
    });

    Object.defineProperty(this, "oy", {
        get: function () {
            return oy;
        },
        set: function (value) {
            setOY(value);
        }
    });

    function setType(value){
        type = value;
        if2d_viewport_setType(vp.id , type);
    }

    function setRadius(value){
        radius = parseInt(value);
        if2d_viewport_setRadius(vp.id , radius);
    }

    function setWidth(value){
        width = value;
        if2d_viewport_setWidth(vp.id , parseInt(width));
    }

    function setHeight(value){
        height = value;
        if2d_viewport_setHeight(vp.id , parseInt(height));
    }

    function setOX(oxv){
        ox = oxv;
        if2d_viewport_setOX(vp.id,ox);
    }

    function setOY(oyv){
        oy = oyv;
        if2d_viewport_setOY(vp.id,oy);
    }

    this.updateMove = function(){
        if(this.dir == IViewport.Dir.Vertical || this.dir == IViewport.Dir.All){
            getEndPosY();
            if(move_bar()) return true;
            if(this.isAutoMove){
                if(auto_bar()) return true;
            }

        }
        if(this.dir == IViewport.Dir.Horizontal || this.dir == IViewport.Dir.All){
            getEndPosX();
            if(move_bar_l()) return true;
            if(this.isAutoMove){
                if(auto_bar_l()) return true;
            }
        }
        return false;
    };


    this.dispose = function(){

        if2d_viewport_dispose(vp.id);
        vp.zbox.removeAll();
        if(vp.fviewporte != null){
            vp.fviewporte.zbox.remove(vp);
        }else{
            IVal.Box.remove(vp);
        }
    };


    this.IsIn = function(){
        var x = vp.x;
        var y = vp.y;
        var right = vp.x + vp.width;
        var bottow = vp.y + vp.height;
        return IInput.x >= x && IInput.x <= right && IInput.y >= y && IInput.y <= bottow;
    };

    this.isShifting = function(){
        return OFrames > 0;
    };

    this.shifting = function( bOX, bOY, eOX, eOY, frames){
        if(frames <= 0){
            this.ox = eOX;
            this.oy = eOY;
        }else{
            OFrames = frames;
            endOX = eOX;
            endOY = eOY;
            diffOX = (eOX - bOX) / (frames * 1.0);
            diffOY = (eOY - bOY) / (frames * 1.0);
            tmpOX = bOX;
            tmpOY = bOY;
            this.ox = bOX;
            this.oy = bOY;
        }
    };

    this.shiftingTo = function( eOX, eOY, frames){
        this.shifting(this.ox,this.oy,eOX,eOY,frames);
    };

    function updateShifting(){
        if(OFrames <= 0) return;
        OFrames -= 1;
        if(OFrames <= 0){
            vp.ox = endOX;
            vp.oy = endOY;
        }else{
            tmpOX += diffOX;
            tmpOY += diffOY;
            vp.ox = parseInt(tmpOX);
            vp.oy = parseInt(tmpOY);
        }
    }

    function getEndPosX(){
        var endMax = 0;
        var list = vp.zbox.getAll();
        for(var i = 0;i<list.length;i++){
            var m = 0;
            m = list[i].x + list[i].width;
            if(m > endMax){
                endMax = m;
            }
        }
        endPosX = endMax + vp.endPosDX;
    }

    function getEndPosY(){
        var endMax = 0;
        var list = vp.zbox.getAll();
        for(var i = 0;i<list.length;i++){
            var m = 0;
            m = list[i].y + list[i].height;
            if(m > endMax){
                endMax = m;
            }
        }
        endPosY = endMax + vp.endPosDY;
    }

    function move_bar(){
        var oldOX = vp.oy;
        var endPos = endPosY - vp.height;

        if(IInput.move && vp.IsIn() && Math.abs(IInput.dy - IInput.y) > 10){
            var pos = vp.oy - (IInput.dy - IInput.y);
            var end = endPos > 0 ? -endPos - 300 : 0;
            if(pos <= 300 && pos >= end){
                if(!vp.isAutoMove){
                    if(pos < vp.height - endPosY) pos = vp.height - endPosY;
                    if(pos > 0) pos = 0;
                }
                vp.oy = pos;
                IInput.dy = IInput.y;
                reMove = true;
            }
            if(Math.abs(oldOX - vp.oy) > 0){
                return true;
            }

        }
        if(IInput.up && reMove){
            reMove = false;
            isMove = true;
        }
        return false;
    }

    function move_bar_l(){
        if(IInput.move && vp.IsIn() && Math.abs(IInput.dx - IInput.x) > 10){
            var pos = vp.ox - (IInput.dx - IInput.x);
            var endpos = endPosX - vp.width ;
            var end = endpos > 0 ? -endpos - 300 : 0;
            if(pos <= 300 && pos >= end){
                if(!vp.isAutoMove){
                    if(pos < vp.width - endPosX) pos = vp.width - endPosX;
                    if(pos > 0) pos = 0;
                }
                vp.ox = pos;
                IInput.dx = IInput.x;
                reMove_l = true;
            }
            return true;
        }
        if(reMove_l && IInput.up){
            reMove_l = false;
            isMove_l = true;
        }
        return false;
    }

    function auto_bar_l(){
        if(!isMove_l) return false;
        var speed = 30;
        var endpos =endPosX - vp.width;
        if(vp.ox > 0){
            if(vp.ox - speed <= 0){
                vp.ox = 0;
                isMove_l = false;
                return false;
            }else{
                vp.ox -= speed;
                return true;
            }
        }else if(vp.ox < -endpos){
            if(vp.ox + speed >= -endpos){
                vp.ox = -endpos;
                isMove_l = false;
                return false;
            }else{
                vp.ox += speed;
                return true;
            }
        }else{
            isMove_l = false;
            return false;
        }
    }

    function auto_bar(){
        if(!isMove) return false;
        var speed = 30;
        var endPos = endPosY - vp.height;
        if(vp.oy > 0){
            if(vp.oy - speed <= 0){
                vp.oy = 0;
                isMove = false;
                return false;
            }else{
                vp.oy -= speed;
                return true;
            }
        }else if(vp.oy < -endPos){
            if(vp.oy + speed >= -endPos){
                vp.oy = -endPos;
                isMove = false;
                return false;
            }else{
                vp.oy += speed;
                return true;
            }
        }else{
            isMove = false;
            return false;
        }
    }

    this.GetRect = function() {
        rect.left = this.x;
        rect.top = this.y;
        rect.right = this.x + (this.width * this.zoomX);
        rect.bottom = this.y + (this.height * this.zoomY);
        return rect;
    };

    this.update = function(){
        this.updatebase();
        vp.zbox.update();
        updateShifting();
    }
}

IViewport.Dir = {
    All: 0,
    Horizontal: 1,
    None: 2,
    Vertical: 3
};

IViewport.Type = {
    Rectangle : 0,
    Round : 1
};
//文件 - IWeb.js
/**
 * Created by 七夕小雨 on 2016/11/10.
 */

function IWeb(){}

IWeb.getUrl = function (url) {
    return if2d_web_getUrl(url);
};
//文件 - SText.js
